%include %{_rpmconfigdir}/macros.python2

%define major 2
%define minor 7
%define fix 15

Name: python%{major}
Version: %{major}.%{minor}.%{fix}
Release: 1
License: Python
Summary: Python 2 Programming Language
Url: https://www.python.org

BuildRequires: openssl-devel < 1.1.0
BuildRequires: zlib-devel
BuildRequires: expat-devel
BuildRequires: libffi-devel
BuildRequires: xz-devel
BuildRequires: bzip2-devel
BuildRequires: ncurses-devel
BuildRequires: readline-devel
BuildRequires: sqlite3-devel
BuildRequires: libutil-devel
# if this is available, _locale will link to it
# Is there a benefit?
# BuildRequires: libintl-devel

Provides: python(abi) = %{major}.%{minor}

Source0: https://www.python.org/ftp/python/%{version}/Python-%{version}.tar.xz
Source1: python2-sitecustomize.py

Patch0: python2-configure.patch
Patch1: python2-Lib_distutils_util.py.patch
Patch2: python2-Lib_sysconfig.py.patch
Patch3: python2-Modules__ctypes_libffi_configure.patch
Patch4: Python-2.7.12-aix.patch
Patch5: Python-2.7.12-aixsetup.patch
Patch6: Python-2.7.12-ldshared.patch
Patch7: Python-2.7.12-linkso.patch
Patch8: Python-2.7.12-pthread-stack-size.patch
Patch9: Python-2.7.12-termios.patch
Patch10: Python-2.7.12-test.patch
Patch11: Python-2.7.13-semaphore.patch


%description
Python is a programming language that lets you work more quickly and integrate your systems more effectively.

You can learn to use Python and see almost immediate gains in productivity and lower maintenance costs.


%package devel
Summary: Python 2 development files
Requires: %{name} = %{version}

%description devel
Python is a programming language that lets you work more quickly and integrate your systems more effectively.

You can learn to use Python and see almost immediate gains in productivity and lower maintenance costs.

%prep
%setup -q -n Python-%{version}

%patch0 -p1
%patch1 -p1
%patch2 -p1
%patch3 -p1
%patch4 -p1
%patch5 -p1
%patch6 -p1
%patch7 -p1
%patch8 -p1
%patch9 -p1
%patch10 -p1
%patch11 -p1

%build

# NOTE: To build with IPV6 support you need the following PTFs applied:
# 7.3: MF63822
# 7.2: MF63833
# 7.1: MF63834
#
# Or you may hit this error during configure:
#
# Fatal: You must get working getaddrinfo() function.
#        or you can specify "--disable-ipv6".

%configure \
  CFLAGS="-maix${OBJECT_MODE} -std=c99 $CFLAGS" \
  CPPFLAGS="-I%{_includedir} -D__PASE__ -D_XOPEN_SOURCE=700 -D_ALL_SOURCE" \
  LDFLAGS="-maix${OBJECT_MODE} -Wl,-brtl -Wl,-blibpath:%{_libdir}:/QOpenSys/usr/lib -L%{_libdir}" \
  ARFLAGS="-X${OBJECT_MODE} rc" \
  --with-gcc \
  --with-threads \
  --with-system-expat \
  --with-system-ffi \
  --with-ensurepip=no \
  --without-computed-gotos \
  --enable-ipv6 \
  --enable-shared
  #end

function undefine
{
  perl -p -i -e "s|#define $1 1|/* #undef $1 */|g" pyconfig.h
}

undefine HAVE_CLOCK_GETRES
undefine HAVE_CLOCK_GETTIME
undefine HAVE_CLOCK_SETTIME
undefine HAVE_POSIX_FADVISE
undefine HAVE_POSIX_FALLOCATE
undefine HAVE_SCHED_RR_GET_INTERVAL
undefine HAVE_SCHED_SETPARAM
undefine HAVE_SCHED_SETSCHEDULER
# undefine HAVE_CHROOT
undefine HAVE_OPENAT
undefine HAVE_FACCESSAT
undefine HAVE_FCHMODAT
undefine HAVE_FCHOWNAT
undefine HAVE_FSTATAT
undefine HAVE_LINKAT
undefine HAVE_MKDIRAT
undefine HAVE_MKFIFOAT
undefine HAVE_MKNODAT
undefine HAVE_OPENAT
undefine HAVE_READLINKAT
undefine HAVE_RENAMEAT
undefine HAVE_SYMLINKAT
undefine HAVE_UNLINKAT
undefine HAVE_UTIMENSAT

# TODO: Ensure -maix32/-maix64 is passed to gcc when used as the linker. This is hacky. Fix it properly
perl -p -i -e "s|ld_so_aix \$(CC)|ld_so_aix \$(CC) -maix${OBJECT_MODE}|" Makefile

perl -p -i -e 's|#! /usr/local/bin/python|#! %{_bindir}/python2|' Lib/cgi.py # Already patched

gmake

%install

gmake install DESTDIR=%{buildroot}

rm %{buildroot}/%{_bindir}/python
rm %{buildroot}/%{_bindir}/python-config
rm %{buildroot}/%{_bindir}/2to3
rm %{buildroot}/%{_bindir}/idle

%define site_packages "%{buildroot}/%{_libdir}/python%{major}.%{minor}/site-packages"

cp %{SOURCE1} %{site_packages}/sitecustomize.py

%files
%defattr(-, qsys, *none)

%{_bindir}/*

%{_libdir}/python%{major}.%{minor}
%{_libdir}/libpython%{major}.%{minor}.so

%{_mandir}/man1/*

%files devel
%defattr(-, qsys, *none)

%{_includedir}/python%{major}.%{minor}
%{_libdir}/pkgconfig/*

%changelog
